diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 35f13b428..693dacd99 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -4,10 +4,18 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.util.dispatch.Dispatcher;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.helper.Side;
+
+import static net.minecraft.client.render.block.model.BlockModelStandard.BLOCK_TEXTURES;
+import static net.minecraft.client.render.block.model.BlockModelStandard.OVERBRIGHT_TEXTURES;
+import static net.minecraft.client.render.block.model.BlockModelStandard.RETRO_BLOCK_TEXTURES;
 
 public class BlockModelDispatcher
     extends Dispatcher<Block<?>, BlockModel<?>>
 {
+    private static final Side[] S_TB = new Side[]{Side.TOP, Side.BOTTOM};
+    private static final Side[] S_SIDES = new Side[]{Side.NORTH, Side.EAST, Side.SOUTH, Side.WEST};
+
     private static BlockModelDispatcher instance = new BlockModelDispatcher();
     public static BlockModelDispatcher getInstance()
     {
@@ -21,7 +29,7 @@ public class BlockModelDispatcher
     @Override
     public void addDispatch(Block<?> key, BlockModel<?> value)
     {
-        if (dispatches.containsValue(key)){
+        if (hasDispatch(key)){
             throw new IllegalArgumentException("Block '" + key.toString() + "' already assigned a model!");
         }
         dispatches.put(key, value);
@@ -34,74 +42,120 @@ public class BlockModelDispatcher
     private BlockModelDispatcher()
     {
         instance = this;
-        addDispatch(new BlockModelStandard<>(Blocks.STONE).withTextures("minecraft:block/stone"));
-        addDispatch(new BlockModelStandard<>(Blocks.BASALT).withTextures("minecraft:block/basalt"));
-        addDispatch(new BlockModelStandard<>(Blocks.LIMESTONE).withTextures("minecraft:block/limestone"));
-        addDispatch(new BlockModelStandard<>(Blocks.GRANITE).withTextures("minecraft:block/granite"));
-        addDispatch(new BlockModelStandard<>(Blocks.MARBLE).withTextures("minecraft:block/marble"));
-        addDispatch(new BlockModelStandard<>(Blocks.SLATE).withTextures("minecraft:block/slate_top", "minecraft:block/slate_side"));
-        addDispatch(new BlockModelStandard<>(Blocks.PERMAFROST).withTextures("minecraft:block/permafrost"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_STONE).withTextures("minecraft:block/cobbled_stone"));
-        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_STONE_MOSSY).withTextures("minecraft:block/cobbled_stone_mossy"));
-        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_BASALT).withTextures("minecraft:block/cobbled_basalt"));
-        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_LIMESTONE).withTextures("minecraft:block/cobbled_limestone"));
-        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_GRANITE).withTextures("minecraft:block/cobbled_granite"));
-        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_PERMAFROST).withTextures("minecraft:block/cobbled_permafrost"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.STONE_POLISHED).withTextures("minecraft:block/polished_stone_top", "minecraft:block/polished_stone_side"));
-        addDispatch(new BlockModelStandard<>(Blocks.GRANITE_POLISHED).withTextures("minecraft:block/polished_granite_top", "minecraft:block/polished_granite_side"));
-        addDispatch(new BlockModelStandard<>(Blocks.LIMESTONE_POLISHED).withTextures("minecraft:block/polished_limestone_top", "minecraft:block/polished_limestone_side"));
-        addDispatch(new BlockModelStandard<>(Blocks.BASALT_POLISHED).withTextures("minecraft:block/polished_basalt_top", "minecraft:block/polished_basalt_side"));
-        addDispatch(new BlockModelStandard<>(Blocks.SLATE_POLISHED).withTextures("minecraft:block/polished_slate_top", "minecraft:block/polished_slate_side"));
-        addDispatch(new BlockModelStandard<>(Blocks.PERMAFROST_POLISHED).withTextures("minecraft:block/polished_permafrost_top", "minecraft:block/polished_permafrost_side"));
-        addDispatch(new BlockModelStandard<>(Blocks.NETHERRACK_POLISHED).withTextures("minecraft:block/polished_netherrack_top", "minecraft:block/polished_netherrack_side"));
-
-        addDispatch(new BlockModelAxisAligned<>(Blocks.PILLAR_MARBLE).withTextures("minecraft:block/pillar_marble/top", "minecraft:block/pillar_marble/side"));
-        addDispatch(new BlockModelStandard<>(Blocks.CAPSTONE_MARBLE).withTextures("minecraft:block/capstone_marble/top", "minecraft:block/capstone_marble/side"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.SANDSTONE).withTextures("minecraft:block/sandstone/top", "minecraft:block/sandstone/bottom", "minecraft:block/sandstone/side"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.STONE_CARVED).withTextures("minecraft:block/polished_stone_top", "minecraft:block/carved_stone"));
-        addDispatch(new BlockModelStandard<>(Blocks.GRANITE_CARVED).withTextures("minecraft:block/polished_granite_top", "minecraft:block/carved_granite"));
-        addDispatch(new BlockModelStandard<>(Blocks.LIMESTONE_CARVED).withTextures("minecraft:block/polished_limestone_top", "minecraft:block/carved_limestone"));
-        addDispatch(new BlockModelStandard<>(Blocks.BASALT_CARVED).withTextures("minecraft:block/polished_basalt_top", "minecraft:block/carved_basalt"));
-        addDispatch(new BlockModelStandard<>(Blocks.PERMAFROST_CARVED).withTextures("minecraft:block/polished_permafrost_top", "minecraft:block/carved_permafrost"));
-        addDispatch(new BlockModelStandard<>(Blocks.NETHERRACK_CARVED).withTextures("minecraft:block/polished_netherrack_top", "minecraft:block/carved_netherrack"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.PLANKS_OAK).withTextures("minecraft:block/planks/oak"));
+        addDispatch(new BlockModelStandard<>(Blocks.STONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/stone"));
+        addDispatch(new BlockModelStandard<>(Blocks.BASALT).setAllTextures(BLOCK_TEXTURES, "minecraft:block/basalt"));
+        addDispatch(new BlockModelStandard<>(Blocks.LIMESTONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/limestone"));
+        addDispatch(new BlockModelStandard<>(Blocks.GRANITE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/granite"));
+        addDispatch(new BlockModelStandard<>(Blocks.MARBLE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/marble"));
+        addDispatch(new BlockModelStandard<>(Blocks.SLATE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/slate_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/slate_side", S_SIDES));
+        addDispatch(new BlockModelStandard<>(Blocks.PERMAFROST).setAllTextures(BLOCK_TEXTURES, "minecraft:block/permafrost"));
+
+        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_STONE)
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_stone")
+            .setAllTextures(RETRO_BLOCK_TEXTURES, "minecraft:block/cobbled_stone_retro")
+        );
+        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_STONE_MOSSY)
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_stone_mossy")
+            .setAllTextures(RETRO_BLOCK_TEXTURES, "minecraft:block/cobbled_stone_mossy_retro")
+        );
+        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_BASALT).setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_basalt"));
+        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_LIMESTONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_limestone"));
+        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_GRANITE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_granite"));
+        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_PERMAFROST).setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_permafrost"));
+
+        addDispatch(new BlockModelStandard<>(Blocks.STONE_POLISHED)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_stone_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_stone_side", S_SIDES));
+        addDispatch(new BlockModelStandard<>(Blocks.GRANITE_POLISHED)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_granite_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_granite_side", S_SIDES));
+        addDispatch(new BlockModelStandard<>(Blocks.LIMESTONE_POLISHED)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_limestone_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_limestone_side", S_SIDES));
+        addDispatch(new BlockModelStandard<>(Blocks.BASALT_POLISHED)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_basalt_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_basalt_side", S_SIDES));
+        addDispatch(new BlockModelStandard<>(Blocks.SLATE_POLISHED)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_slate_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_slate_side", S_SIDES));
+        addDispatch(new BlockModelStandard<>(Blocks.PERMAFROST_POLISHED)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_permafrost_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_permafrost_side", S_SIDES));
+        addDispatch(new BlockModelStandard<>(Blocks.NETHERRACK_POLISHED)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_netherrack_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_netherrack_side", S_SIDES));
+
+        addDispatch(new BlockModelAxisAligned<>(Blocks.PILLAR_MARBLE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/pillar_marble/top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/pillar_marble/side", S_SIDES));
+        addDispatch(new BlockModelStandard<>(Blocks.CAPSTONE_MARBLE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/capstone_marble/top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/capstone_marble/side", S_SIDES));
+
+        addDispatch(new BlockModelStandard<>(Blocks.SANDSTONE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/sandstone/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/sandstone/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/sandstone/side", S_SIDES));
+
+        addDispatch(new BlockModelStandard<>(Blocks.STONE_CARVED)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_stone_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/carved_stone", S_SIDES));
+        addDispatch(new BlockModelStandard<>(Blocks.GRANITE_CARVED)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_granite_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/carved_granite", S_SIDES));
+        addDispatch(new BlockModelStandard<>(Blocks.LIMESTONE_CARVED)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_limestone_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/carved_limestone", S_SIDES));
+        addDispatch(new BlockModelStandard<>(Blocks.BASALT_CARVED)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_basalt_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/carved_basalt", S_SIDES));
+        addDispatch(new BlockModelStandard<>(Blocks.PERMAFROST_CARVED)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_permafrost_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/carved_permafrost", S_SIDES));
+        addDispatch(new BlockModelStandard<>(Blocks.NETHERRACK_CARVED)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_netherrack_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/carved_netherrack", S_SIDES));
+
+        addDispatch(new BlockModelStandard<>(Blocks.PLANKS_OAK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/planks/oak"));
         addDispatch(new BlockModelPlanksPainted<>(Blocks.PLANKS_OAK_PAINTED));
 
-        addDispatch(new BlockModelTorch<>(Blocks.TORCH_COAL).withTextures("minecraft:block/torch_coal"));
+        addDispatch(new BlockModelTorch<>(Blocks.TORCH_COAL).setAllTextures(BLOCK_TEXTURES, "minecraft:block/torch_coal"));
 
-        addDispatch(new BlockModelLadder<>(Blocks.LADDER_OAK).withTextures("minecraft:block/ladder"));
+        addDispatch(new BlockModelLadder<>(Blocks.LADDER_OAK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ladder"));
 
-        addDispatch(new BlockModelFence<>(Blocks.FENCE_PLANKS_OAK).withTextures("minecraft:block/planks/oak"));
+        addDispatch(new BlockModelFence<>(Blocks.FENCE_PLANKS_OAK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/planks/oak"));
         addDispatch(new BlockModelFencePainted<>(Blocks.FENCE_PLANKS_OAK_PAINTED));
 
-        addDispatch(new BlockModelFenceGate<>(Blocks.FENCE_GATE_PLANKS_OAK).withTextures("minecraft:block/planks/oak"));
+        addDispatch(new BlockModelFenceGate<>(Blocks.FENCE_GATE_PLANKS_OAK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/planks/oak"));
         addDispatch(new BlockModelFenceGatePainted<>(Blocks.FENCE_GATE_PLANKS_OAK_PAINTED));
 
-        addDispatch(new BlockModelStandard<>(Blocks.BOOKSHELF_PLANKS_OAK).withTextures("minecraft:block/bookshelf/top", "minecraft:block/bookshelf/side"));
+        addDispatch(new BlockModelStandard<>(Blocks.BOOKSHELF_PLANKS_OAK)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/bookshelf/top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/bookshelf/side", S_SIDES));
 
         addDispatch(new BlockModelWool<>(Blocks.WOOL));
-        addDispatch(new BlockModelRope<>(Blocks.ROPE).withTextures("minecraft:block/rope"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.BRICK_CLAY).withTextures("minecraft:block/brick_clay"));
-        addDispatch(new BlockModelStandard<>(Blocks.BRICK_STONE_POLISHED).withTextures("minecraft:block/brick_polished_stone"));
-        addDispatch(new BlockModelStandard<>(Blocks.BRICK_STONE_POLISHED_MOSSY).withTextures("minecraft:block/brick_polished_stone_mossy"));
-        addDispatch(new BlockModelStandard<>(Blocks.BRICK_SANDSTONE).withTextures("minecraft:block/brick_sandstone"));
-        addDispatch(new BlockModelStandard<>(Blocks.BRICK_GOLD).withTextures("minecraft:block/brick_gold"));
-        addDispatch(new BlockModelStandard<>(Blocks.BRICK_LAPIS).withTextures("minecraft:block/brick_lapis"));
-        addDispatch(new BlockModelStandard<>(Blocks.BRICK_BASALT).withTextures("minecraft:block/brick_basalt"));
-        addDispatch(new BlockModelStandard<>(Blocks.BRICK_LIMESTONE).withTextures("minecraft:block/brick_limestone"));
-        addDispatch(new BlockModelStandard<>(Blocks.BRICK_GRANITE).withTextures("minecraft:block/brick_granite"));
-        addDispatch(new BlockModelStandard<>(Blocks.BRICK_MARBLE).withTextures("minecraft:block/brick_marble"));
-        addDispatch(new BlockModelStandard<>(Blocks.BRICK_SLATE).withTextures("minecraft:block/brick_slate"));
-        addDispatch(new BlockModelStandard<>(Blocks.BRICK_STONE).withTextures("minecraft:block/brick_stone"));
-        addDispatch(new BlockModelStandard<>(Blocks.BRICK_PERMAFROST).withTextures("minecraft:block/brick_permafrost"));
-        addDispatch(new BlockModelStandard<>(Blocks.BRICK_IRON).withTextures("minecraft:block/brick_iron"));
-        addDispatch(new BlockModelStandard<>(Blocks.BRICK_STEEL).withTextures("minecraft:block/brick_steel"));
+        addDispatch(new BlockModelRope<>(Blocks.ROPE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/rope"));
+
+        addDispatch(new BlockModelStandard<>(Blocks.BRICK_CLAY)
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/brick_clay")
+            .setAllTextures(RETRO_BLOCK_TEXTURES, "minecraft:block/brick_clay_retro")
+        );
+        addDispatch(new BlockModelStandard<>(Blocks.BRICK_STONE_POLISHED).setAllTextures(BLOCK_TEXTURES, "minecraft:block/brick_polished_stone"));
+        addDispatch(new BlockModelStandard<>(Blocks.BRICK_STONE_POLISHED_MOSSY).setAllTextures(BLOCK_TEXTURES, "minecraft:block/brick_polished_stone_mossy"));
+        addDispatch(new BlockModelStandard<>(Blocks.BRICK_SANDSTONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/brick_sandstone"));
+        addDispatch(new BlockModelStandard<>(Blocks.BRICK_GOLD).setAllTextures(BLOCK_TEXTURES, "minecraft:block/brick_gold"));
+        addDispatch(new BlockModelStandard<>(Blocks.BRICK_LAPIS).setAllTextures(BLOCK_TEXTURES, "minecraft:block/brick_lapis"));
+        addDispatch(new BlockModelStandard<>(Blocks.BRICK_BASALT).setAllTextures(BLOCK_TEXTURES, "minecraft:block/brick_basalt"));
+        addDispatch(new BlockModelStandard<>(Blocks.BRICK_LIMESTONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/brick_limestone"));
+        addDispatch(new BlockModelStandard<>(Blocks.BRICK_GRANITE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/brick_granite"));
+        addDispatch(new BlockModelStandard<>(Blocks.BRICK_MARBLE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/brick_marble"));
+        addDispatch(new BlockModelStandard<>(Blocks.BRICK_SLATE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/brick_slate"));
+        addDispatch(new BlockModelStandard<>(Blocks.BRICK_STONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/brick_stone"));
+        addDispatch(new BlockModelStandard<>(Blocks.BRICK_PERMAFROST).setAllTextures(BLOCK_TEXTURES, "minecraft:block/brick_permafrost"));
+        addDispatch(new BlockModelStandard<>(Blocks.BRICK_IRON).setAllTextures(BLOCK_TEXTURES, "minecraft:block/brick_iron"));
+        addDispatch(new BlockModelStandard<>(Blocks.BRICK_STEEL).setAllTextures(BLOCK_TEXTURES, "minecraft:block/brick_steel"));
 
         addDispatch(new BlockModelSlab<>(Blocks.SLAB_PLANKS_OAK));
         addDispatch(new BlockModelSlab<>(Blocks.SLAB_COBBLE_STONE));
@@ -147,56 +201,100 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelStairs<>(Blocks.STAIRS_BRICK_SANDSTONE));
         addDispatch(new BlockModelStairs<>(Blocks.STAIRS_BRICK_PERMAFROST));
 
-        addDispatch(new BlockModelStandard<>(Blocks.OBSIDIAN).withTextures("minecraft:block/obsidian"));
-
-        addDispatch(new BlockModelTransparent<>(Blocks.GLASS, false).withTextures("minecraft:block/glass"));
-        addDispatch(new BlockModelTransparent<>(Blocks.GLASS_TINTED, false).onRenderLayer(1).withTextures("minecraft:block/glass_tinted"));
-        addDispatch(new BlockModelTransparent<>(Blocks.GLASS_STEEL, false).withTextures("minecraft:block/glass_steel"));
-
-        addDispatch(new BlockModelGrass<>(Blocks.GRASS).withTextures("minecraft:block/grass/top", "minecraft:block/grass/bottom", "minecraft:block/grass/side"));
-        addDispatch(new BlockModelStandard<>(Blocks.GRASS_RETRO).withTextures("minecraft:block/grass_retro/top", "minecraft:block/grass_retro/bottom", "minecraft:block/grass_retro/side"));
-        addDispatch(new BlockModelStandard<>(Blocks.GRASS_SCORCHED).withTextures("minecraft:block/grass_scorched/top", "minecraft:block/grass_scorched/bottom", "minecraft:block/grass_scorched/side"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.PATH_DIRT).withTextures("minecraft:block/grass_path/top", "minecraft:block/grass_path/bottom", "minecraft:block/grass_path/side"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.DIRT).withTextures("minecraft:block/dirt"));
-        addDispatch(new BlockModelStandard<>(Blocks.DIRT_SCORCHED).withTextures("minecraft:block/dirt_scorched"));
-        addDispatch(new BlockModelStandard<>(Blocks.DIRT_SCORCHED_RICH).withTextures("minecraft:block/dirt_scorched_rich"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.MUD).withTextures("minecraft:block/mud"));
-        addDispatch(new BlockModelStandard<>(Blocks.MUD_BAKED).withTextures("minecraft:block/mud_baked"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.SPONGE_DRY).withTextures("minecraft:block/sponge"));
-        addDispatch(new BlockModelStandard<>(Blocks.SPONGE_WET).withTextures("minecraft:block/sponge_wet"));
-        addDispatch(new BlockModelPumice<>(Blocks.PUMICE_DRY).withTextures("minecraft:block/pumice"));
-        addDispatch(new BlockModelPumice<>(Blocks.PUMICE_WET).withTextures("minecraft:block/pumice_overlay"));
-
-        addDispatch(new BlockModelStoneMossy<>(Blocks.MOSS_STONE).withTextures("minecraft:block/stone"));
-        addDispatch(new BlockModelStoneMossy<>(Blocks.MOSS_BASALT).withTextures("minecraft:block/basalt"));
-        addDispatch(new BlockModelStoneMossy<>(Blocks.MOSS_LIMESTONE).withTextures("minecraft:block/limestone"));
-        addDispatch(new BlockModelStoneMossy<>(Blocks.MOSS_GRANITE).withTextures("minecraft:block/granite"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.SAND).withTextures("minecraft:block/sand"));
-        addDispatch(new BlockModelStandard<>(Blocks.GRAVEL).withTextures("minecraft:block/gravel"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.BEDROCK).withTextures("minecraft:block/bedrock"));
-        addDispatch(new BlockModelFullyRotatable<>(Blocks.BONESHALE).withTextures("minecraft:block/bone_shale/top", "minecraft:block/bone_shale/bottom", "minecraft:block/bone_shale/side"));
-
-        addDispatch(new BlockModelFluid<>(Blocks.FLUID_WATER_FLOWING).onRenderLayer(1).withTextures("minecraft:block/water_still", "minecraft:block/water_flowing", "minecraft:block/water_flowing"));
-        addDispatch(new BlockModelFluid<>(Blocks.FLUID_WATER_STILL).onRenderLayer(1).withTextures("minecraft:block/water_still", "minecraft:block/water_flowing"));
-        addDispatch(new BlockModelFluid<>(Blocks.FLUID_LAVA_FLOWING).withTextures("minecraft:block/lava_still", "minecraft:block/lava_flowing", "minecraft:block/lava_flowing"));
-        addDispatch(new BlockModelFluid<>(Blocks.FLUID_LAVA_STILL).withTextures("minecraft:block/lava_still", "minecraft:block/lava_flowing"));
-
-        addDispatch(new BlockModelAxisAligned<>(Blocks.LOG_OAK).withTextures("minecraft:block/log/oak_top", "minecraft:block/log/oak_side"));
-        addDispatch(new BlockModelAxisAligned<>(Blocks.LOG_PINE).withTextures("minecraft:block/log/pine_top", "minecraft:block/log/pine_side"));
-        addDispatch(new BlockModelAxisAligned<>(Blocks.LOG_BIRCH).withTextures("minecraft:block/log/birch_top", "minecraft:block/log/birch_side"));
-        addDispatch(new BlockModelAxisAligned<>(Blocks.LOG_CHERRY).withTextures("minecraft:block/log/cherry_top", "minecraft:block/log/cherry_side"));
-        addDispatch(new BlockModelAxisAligned<>(Blocks.LOG_EUCALYPTUS).withTextures("minecraft:block/log/eucalyptus_top", "minecraft:block/log/eucalyptus_side"));
-        addDispatch(new BlockModelAxisAligned<>(Blocks.LOG_OAK_MOSSY).withTextures("minecraft:block/log/oak_mossy_top", "minecraft:block/log/oak_mossy_side"));
-        addDispatch(new BlockModelAxisAligned<>(Blocks.LOG_THORN).withTextures("minecraft:block/log/thorn_top", "minecraft:block/log/thorn_side"));
-        addDispatch(new BlockModelAxisAligned<>(Blocks.LOG_PALM).withTextures("minecraft:block/log/palm_top", "minecraft:block/log/palm_side"));
-
-        addDispatch(new BlockModelLeaves<>(Blocks.LEAVES_OAK, "minecraft:block/leaves/oak"));
+        addDispatch(new BlockModelStandard<>(Blocks.OBSIDIAN).setAllTextures(BLOCK_TEXTURES, "minecraft:block/obsidian"));
+
+        addDispatch(new BlockModelTransparent<>(Blocks.GLASS, false).setAllTextures(BLOCK_TEXTURES, "minecraft:block/glass"));
+        addDispatch(new BlockModelTransparent<>(Blocks.GLASS_TINTED, false).onRenderLayer(1).setAllTextures(BLOCK_TEXTURES, "minecraft:block/glass_tinted"));
+        addDispatch(new BlockModelTransparent<>(Blocks.GLASS_STEEL, false).setAllTextures(BLOCK_TEXTURES, "minecraft:block/glass_steel"));
+
+        addDispatch(new BlockModelGrass<>(Blocks.GRASS)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/grass/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/grass/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/grass/side", S_SIDES)
+            .setTex(RETRO_BLOCK_TEXTURES, "minecraft:block/grass_retro/top", Side.TOP)
+            .setTex(RETRO_BLOCK_TEXTURES, "minecraft:block/grass_retro/bottom", Side.BOTTOM)
+            .setTex(RETRO_BLOCK_TEXTURES, "minecraft:block/grass_retro/side", S_SIDES));
+        addDispatch(new BlockModelStandard<>(Blocks.GRASS_RETRO)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/grass_retro/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/grass_retro/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/grass_retro/side", S_SIDES));
+        addDispatch(new BlockModelStandard<>(Blocks.GRASS_SCORCHED)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/grass_scorched/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/grass_scorched/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/grass_scorched/side", S_SIDES));
+
+        addDispatch(new BlockModelStandard<>(Blocks.PATH_DIRT)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/grass_path/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/grass_path/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/grass_path/side", S_SIDES));
+
+        addDispatch(new BlockModelStandard<>(Blocks.DIRT).setAllTextures(BLOCK_TEXTURES, "minecraft:block/dirt"));
+        addDispatch(new BlockModelStandard<>(Blocks.DIRT_SCORCHED).setAllTextures(BLOCK_TEXTURES, "minecraft:block/dirt_scorched"));
+        addDispatch(new BlockModelStandard<>(Blocks.DIRT_SCORCHED_RICH).setAllTextures(BLOCK_TEXTURES, "minecraft:block/dirt_scorched_rich"));
+
+        addDispatch(new BlockModelStandard<>(Blocks.MUD).setAllTextures(BLOCK_TEXTURES, "minecraft:block/mud"));
+        addDispatch(new BlockModelStandard<>(Blocks.MUD_BAKED).setAllTextures(BLOCK_TEXTURES, "minecraft:block/mud_baked"));
+
+        addDispatch(new BlockModelStandard<>(Blocks.SPONGE_DRY).setAllTextures(BLOCK_TEXTURES, "minecraft:block/sponge"));
+        addDispatch(new BlockModelStandard<>(Blocks.SPONGE_WET).setAllTextures(BLOCK_TEXTURES, "minecraft:block/sponge_wet"));
+        addDispatch(new BlockModelPumice<>(Blocks.PUMICE_DRY).setAllTextures(BLOCK_TEXTURES, "minecraft:block/pumice"));
+        addDispatch(new BlockModelPumice<>(Blocks.PUMICE_WET).setAllTextures(BLOCK_TEXTURES, "minecraft:block/pumice_overlay"));
+
+        addDispatch(new BlockModelStoneMossy<>(Blocks.MOSS_STONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/stone"));
+        addDispatch(new BlockModelStoneMossy<>(Blocks.MOSS_BASALT).setAllTextures(BLOCK_TEXTURES, "minecraft:block/basalt"));
+        addDispatch(new BlockModelStoneMossy<>(Blocks.MOSS_LIMESTONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/limestone"));
+        addDispatch(new BlockModelStoneMossy<>(Blocks.MOSS_GRANITE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/granite"));
+
+        addDispatch(new BlockModelStandard<>(Blocks.SAND).setAllTextures(BLOCK_TEXTURES, "minecraft:block/sand"));
+        addDispatch(new BlockModelStandard<>(Blocks.GRAVEL).setAllTextures(BLOCK_TEXTURES, "minecraft:block/gravel"));
+
+        addDispatch(new BlockModelStandard<>(Blocks.BEDROCK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/bedrock"));
+        addDispatch(new BlockModelFullyRotatable<>(Blocks.BONESHALE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/bone_shale/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/bone_shale/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/bone_shale/side", S_SIDES));
+
+        addDispatch(new BlockModelFluid<>(Blocks.FLUID_WATER_FLOWING)
+            .onRenderLayer(1)
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/water_flowing")
+            .setTex(BLOCK_TEXTURES, "minecraft:block/water_still", Side.TOP));
+        addDispatch(new BlockModelFluid<>(Blocks.FLUID_WATER_STILL)
+            .onRenderLayer(1)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/water_still", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/water_flowing", S_SIDES));
+        addDispatch(new BlockModelFluid<>(Blocks.FLUID_LAVA_FLOWING)
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/lava_flowing")
+            .setTex(BLOCK_TEXTURES, "minecraft:block/lava_still", Side.TOP));
+        addDispatch(new BlockModelFluid<>(Blocks.FLUID_LAVA_STILL)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/lava_still", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/lava_flowing", S_SIDES));
+
+        addDispatch(new BlockModelAxisAligned<>(Blocks.LOG_OAK)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/log/oak_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/log/oak_side", S_SIDES));
+        addDispatch(new BlockModelAxisAligned<>(Blocks.LOG_PINE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/log/pine_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/log/pine_side", S_SIDES));
+        addDispatch(new BlockModelAxisAligned<>(Blocks.LOG_BIRCH)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/log/birch_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/log/birch_side", S_SIDES));
+        addDispatch(new BlockModelAxisAligned<>(Blocks.LOG_CHERRY)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/log/cherry_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/log/cherry_side", S_SIDES));
+        addDispatch(new BlockModelAxisAligned<>(Blocks.LOG_EUCALYPTUS)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/log/eucalyptus_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/log/eucalyptus_side", S_SIDES));
+        addDispatch(new BlockModelAxisAligned<>(Blocks.LOG_OAK_MOSSY)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/log/oak_mossy_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/log/oak_mossy_side", S_SIDES));
+        addDispatch(new BlockModelAxisAligned<>(Blocks.LOG_THORN)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/log/thorn_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/log/thorn_side", S_SIDES));
+        addDispatch(new BlockModelAxisAligned<>(Blocks.LOG_PALM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/log/palm_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/log/palm_side", S_SIDES));
+
+        addDispatch(new BlockModelLeaves<>(Blocks.LEAVES_OAK, "minecraft:block/leaves/oak", true));
         addDispatch(new BlockModelLeaves<>(Blocks.LEAVES_OAK_RETRO, "minecraft:block/leaves/oak_retro"));
         addDispatch(new BlockModelLeaves<>(Blocks.LEAVES_PINE, "minecraft:block/leaves/pine"));
         addDispatch(new BlockModelLeaves<>(Blocks.LEAVES_BIRCH, "minecraft:block/leaves/birch"));
